/*
Ce fichier donne le code Python associé aux blocs spécifiques à l'extension Sophus de Blockly.
*/

Blockly.Python['sophus_carre'] = function(block) {
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' * ' + varName + '\n';
};

Blockly.Python['sophus_doubler'] = function(block) {
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var choix = block.getFieldValue('CHOIX');
  return varName + ' = ' + varName +
      ' * ' + choix + '\n';
};

Blockly.Python['sophus_augmenter'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'DELTA',
      Blockly.Python.ORDER_ADDITIVE) || '0';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' + ' + argument0 + '\n';
};

Blockly.Python['sophus_diminuer'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'DELTA',
      Blockly.Python.ORDER_ADDITIVE) || '0';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' - ' + argument0 + '\n';
};

Blockly.Python['sophus_multiplier'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'DELTA',
      Blockly.Python.ORDER_ADDITIVE) || '0';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' * ' + argument0 + '\n';
};

Blockly.Python['sophus_diviser'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'DELTA',
      Blockly.Python.ORDER_ADDITIVE) || '0';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' / ' + argument0 + '\n';
};

Blockly.Python['sophus_augmenter_pct'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'DELTA',
      Blockly.Python.ORDER_ADDITIVE) || '0';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' * (1 + ' + argument0 + ' / 100.0)' + '\n';
};

Blockly.Python['sophus_diminuer_pct'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'DELTA',
      Blockly.Python.ORDER_ADDITIVE) || '0';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = ' + varName +
      ' * (1 - ' + argument0 + ' / 100.0)' + '\n';
};

Blockly.Python['sophus_inverser'] = function(block) {
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = 1.0 / ' + varName + '\n';
};

Blockly.Python['sophus_puissance'] = function(block) {
  var argument0 = Blockly.Python.valueToCode(block, 'POW',
      Blockly.Python.ORDER_ADDITIVE) || '1';
  var varName = Blockly.Python.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return varName + ' = pow(' + varName +
      ' , ' + argument0 + ')' + '\n';
};
